#include "header.h"
#include "gfxlib.h"
#include "bmp.h"

#define FORM ((dword)(('M'<<24)+('R'<<16)+('O'<<8)+('F')))
#define ILBM ((dword)(('M'<<24)+('B'<<16)+('L'<<8)+('I')))

#define ANNO ((dword)(('O'<<24)+('N'<<16)+('N'<<8)+('A')))
#define BMHD ((dword)(('D'<<24)+('H'<<16)+('M'<<8)+('B')))
#define CMAP ((dword)(('P'<<24)+('A'<<16)+('M'<<8)+('C')))
#define BODY ((dword)(('Y'<<24)+('D'<<16)+('O'<<8)+('B')))

void byte_swap( void *data, word size );
void process_chunk ( FILE *fp, raw_img *rimg );
void read_lbm ( byte *filename, raw_img *rimg );


typedef struct {
  dword id;
  void (*process)( FILE *fp, raw_img *rimg );
} dispatch_entry;

typedef struct {
  dword id;
  dword length;
} iff_header;


void read_ANNO ( FILE *fp, raw_img *rimg );
void read_BMHD ( FILE *fp, raw_img *rimg );
void read_CMAP ( FILE *fp, raw_img *rimg );
void read_BODY ( FILE *fp, raw_img *rimg );

typedef struct {
   dword size;
   word width;
   word height;
   word orgx;
   word orgy;
   byte depth;
   byte mask;
   byte compressed;
   byte pad;
   word transparent;
   byte aspx;
   byte aspy;
   word pwidth;
   word pheight;
} BMHD_header;
